unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

{ Forward-Deklaration der Assemblerfunktion }
function _asmcos(arg:double):double;

implementation

{$R *.DFM}

{ Assemblerfunktion einbinden und das obj-file hinzulinken }
function _asmcos(arg:double):double; external; {$L asmcos.obj}

{ Performacevergleich }
procedure TForm1.Button1Click(Sender: TObject);
var
  starttime : Integer;     // Zeitpunkt des Teststartes
  middletime: Integer;     // Zeitpunkt des Funktionswechsels
  i         : Integer;     // Schleifenvariable
  tmp       : Double;      // sinnlose variable die nur als Mlleimer verwendet wird
  oft       : Integer;     // Anzahl der Schleifendurchlufe
begin
  // da 5 berechungen pro schleife sind, sind das je 5 Millionen Berechnungen
  oft := 1000000;
  with Memo1.Lines do
  Begin
    // meine Funktion ausstoppen
    starttime := GetTickCount;
    for i := 0 to oft do
    Begin
      tmp := _asmcos(-2147483647+2147483647*i/(oft/2));
      tmp := _asmcos(-2147483647+2147483647*i/(oft/2));
      tmp := _asmcos(-2147483647+2147483647*i/(oft/2));
      tmp := _asmcos(-2147483647+2147483647*i/(oft/2));
      tmp := _asmcos(-2147483647+2147483647*i/(oft/2));
    end;

    middletime := GetTickCount;

    // die FPU funktion ausstoppen
    for i := 0 to oft do
    Begin
      tmp := cos(-2147483647+2147483647*i/(oft/2));
      tmp := cos(-2147483647+2147483647*i/(oft/2));
      tmp := cos(-2147483647+2147483647*i/(oft/2));
      tmp := cos(-2147483647+2147483647*i/(oft/2));
      tmp := cos(-2147483647+2147483647*i/(oft/2));
    end;

    // Ergebnisse ausgeben
    Add(Format('%dms fr %d durchlufe bei asmcos  5 Berechnungen',[middletime - starttime,oft]));
    Add(Format('%dms fr %d durchlufe bei cos  5 Berechnungen',[GetTickCount - middletime,oft]));
  end;
end;

{ Wertevergleich }
procedure TForm1.Button2Click(Sender: TObject);
var
  i: Integer;
begin
  // 80 Berechnungen in PI/8 Schritten .... really easy
  with Memo1.Lines do
  Begin
    for i := -40 to 40 do
      Add(Format('%dPI/8: cos: %1.14f   - asmcos: %1.14f',[i,cos(i*PI/8),_asmcos(i*PI/8)]));
  end;
end;

end.
